poj3928pingpong区间和

  题意:给出n; n个人有n个不同的技能值  问 任取三个人 使得 中间那人的 技能值也在其他两人之间。

树状数组

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <climits>
#include <string>
#include <iostream>
#include <map>
#include <cstdlib>
#include <list>
#include <set>
#include <queue>
#include <stack>
#include <math.h>
using namespace std;

typedef long long LL;
const LL maxn = 100000 + 100;
LL Max;
LL c[maxn];
LL zuomin[maxn],youmin[maxn],zuomax[maxn],youmax[maxn];
LL lowbit(LL x)
{
    return x&(-x);
}

void update(LL x, LL add)
{
    while (x <= Max){
        c[x] += add;
        x += lowbit(x);
    }
}

LL ask(LL x)
{
    LL ans = 0;
    while (x > 0){
        ans += c[x];
        x -= lowbit(x);
    }
    return ans;
}

int main()
{
    LL n;
    LL a[maxn],Icase;
    cin>>Icase;
    while (Icase--){
        cin>>n;
        Max = -1;
        for (LL i = 1; i <= n; i++)
            cin >> a[i],Max = max(Max,a[i]);
        memset(c, 0, sizeof(c));
        for (LL i = 1; i <= n; i++){
            zuomin[i] = ask(a[i]); zuomax[i]= ask(Max) - ask(a[i]);
            update(a[i], 1);//边统计左边比他大和比他小的 ,边插
        }
        memset(c, 0, sizeof(c));
        for (LL i = n; i >= 1; i--){
            youmin[i] = ask(a[i]); youmax[i] = ask(Max) - ask(a[i]);
            update(a[i], 1);
        }
        LL ans = 0;
        for (LL i = 1; i <= n; i++){
            ans += zuomin[i] * youmax[i];
            ans += zuomax[i] * youmin[i];
        }
        cout << ans << endl;
    }
    return 0;
}

线段树

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <climits>
#include <string>
#include <iostream>
#include <map>
#include <cstdlib>
#include <list>
#include <set>
#include <queue>
#include <stack>
#include <math.h>
using namespace std;
typedef long long LL;
const int maxn = 100000 + 100;
#define lson l,mid,rt<<1
#define rson mid+1,r,rt<<1|1
int sum[maxn * 4];
int zuomin[maxn], youmin[maxn], zuomax[maxn], youmax[maxn];
void up(int rt)
{
    sum[rt] = sum[rt << 1] + sum[rt << 1 | 1];
}
void build(int l, int r, int rt)
{
    sum[rt] = 0;
    if (l == r) return;
    int mid = (l + r) >> 1;
    build(lson);
    build(rson);
}
void update(int pos, int add, int l, int r, int rt)
{
    if (l == r){
        sum[rt] = 1; return;
    }
    int mid = (l + r) >> 1;
    if (pos <= mid) update(pos, add, lson);
    else update(pos, add, rson);
    up(rt);
}

int ask(int L, int R, int l, int r, int rt)
{
    if (L <= l&&r <= R) return sum[rt];
    int mid = (l + r) >> 1;
    int ans = 0;
    if (L <= mid) ans += ask(L, R, lson);
    if (R > mid) ans += ask(L, R, rson);
    return ans;
}
int main()
{
    int Icase;
    int n, Max;
    int a[maxn];
    cin >> Icase;
    while (Icase--){
        cin >> n;
        Max = -1;
        for (int i = 1; i <= n; i++) scanf("%d", &a[i]), Max = max(Max, a[i]);
        build(1, Max, 1);
        for (int i = 1; i <= n; i++){
            zuomin[i] = ask(1,a[i],1,Max,1); zuomax[i] = ask(1,Max,1,Max,1) - ask(1,a[i],1,Max,1);
            update(a[i], 1,1,Max,1);
        }
        build(1, Max, 1);
        for (int i = n; i >= 1; i--){
            youmin[i] = ask(1,a[i],1,Max,1); youmax[i] = ask(1,Max,1,Max,1) - ask(1,a[i],1,Max,1);
            update(a[i], 1,1,Max,1);
        }
        LL ans = 0;
        for (int i = 1; i <= n; i++){
            ans += zuomin[i] * youmax[i];
            ans += zuomax[i] * youmin[i];
        }
        cout << ans << endl;

    }
    return 0;
}
时间: 2024-09-28 02:15:36

poj3928pingpong区间和的相关文章

饥饿的牛 线性dp内的区间

饥饿的牛 牛在饲料槽前排好了队.饲料槽依次用1到N(1<=N<=100000)编号.每天晚上,一头幸运的牛根据约翰的规则,吃其中一些槽里的饲料. 约翰提供B个区间的清单.一个区间是一对整数start-end,1<=start<=end<=N,表示一些连续的饲料槽,比如1-3,7-8,3-4等等.牛可以任意选择区间,但是牛选择的区间不能有重叠.当然,牛希望自己能够吃得越多越好.给出一些区间,帮助这只牛找一些区间,使它能吃到最多的东西.在上面的例子中,1-3和3-4是重叠的:聪明

POJ - 3186 Treats for the Cows (区间DP)

题目链接:http://poj.org/problem?id=3186 题意:给定一组序列,取n次,每次可以取序列最前面的数或最后面的数,第n次出来就乘n,然后求和的最大值. 题解:用dp[i][j]表示i~j区间和的最大值,然后根据这个状态可以从删前和删后转移过来,推出状态转移方程: dp[i][j]=max(dp[i+1][j]+value[i]*k,dp[i][j-1]+value[j]*k) 1 #include <iostream> 2 #include <algorithm&

[Noi2016]区间

题目描述 在数轴上有 n个闭区间 [l1,r1],[l2,r2],...,[ln,rn].现在要从中选出 m 个区间,使得这 m个区间共同包含至少一个位置.换句话说,就是使得存在一个 x,使得对于每一个被选中的区间 [li,ri],都有 li≤x≤ri. 对于一个合法的选取方案,它的花费为被选中的最长区间长度减去被选中的最短区间长度.区间 [li,ri] 的长度定义为 ri?li,即等于它的右端点的值减去左端点的值. 求所有合法方案中最小的花费.如果不存在合法的方案,输出 ?1. 输入输出格式

7620:区间合并

7620:区间合并 总时间限制: 1000ms 内存限制: 65536kB 描述 给定 n 个闭区间 [ai; bi],其中i=1,2,...,n.任意两个相邻或相交的闭区间可以合并为一个闭区间.例如,[1;2] 和 [2;3] 可以合并为 [1;3],[1;3] 和 [2;4] 可以合并为 [1;4],但是[1;2] 和 [3;4] 不可以合并. 我们的任务是判断这些区间是否可以最终合并为一个闭区间,如果可以,将这个闭区间输出,否则输出no. 输入 第一行为一个整数n,3 ≤ n ≤ 5000

luogu 1712 区间(线段树+尺取法)

题意:给出n个区间,求选择一些区间,使得一个点被覆盖的次数超过m次,最小的花费.花费指的是选择的区间中最大长度减去最小长度. 坐标值这么大,n比较小,显然需要离散化,需要一个技巧,把区间转化为半开半闭区间,然后线段树的每一个节点表示一个半开半闭区间. 接着我们注意到需要求最小的花费,且这个花费只与选择的区间集合中的最大长度和最小长度有关. 这意味着如果最大长度和最小长度一定,我们显然是需要把中间长度的区间尽量的选择进去使答案不会变的更劣. 不妨把区间按长度排序,枚举每个最小长度区间,然后最大区间

HDU 1754 I Hate It(线段树之单点更新,区间最值)

I Hate It Time Limit: 9000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 70863    Accepted Submission(s): 27424 Problem Description 很多学校流行一种比较的习惯.老师们很喜欢询问,从某某到某某当中,分数最高的是多少. 这让很多学生很反感.不管你喜不喜欢,现在需要你做的是,就是按照老师的

dutacm.club 1094: 等差区间(RMQ区间最大、最小值,区间GCD)

1094: 等差区间 Time Limit:5000/3000 MS (Java/Others)   Memory Limit:163840/131072 KB (Java/Others)Total Submissions:655   Accepted:54 [Submit][Status][Discuss] Description 已知一个长度为 n 的数组 a[1],a[2],-,a[n],我们进行 q 次询问,每次询问区间 a[l],a[l+1],-,a[r?1],a[r] ,数字从小到大

【uva 1615】Highway(算法效率--贪心 区间选点问题)

题意:给定平面上N个点和一个值D,要求在x轴上选出尽量少的点,使得对于给定的每个店,都有一个选出的点离它的欧几里德距离不超过D. 解法:先把问题转换成模型,把对平面的点满足条件的点在x轴的直线上可得到一个个区间,这样就是选最小的点覆盖所有的区间的问题了.我之前的一篇博文有较详细的解释:关于贪心算法的经典问题(算法效率 or 动态规划).代码实现我先空着.挖坑~

CF149D. Coloring Brackets[区间DP !]

不知道为什么居中了,先把代码放这 #include<iostream> #include<cstdio> #include<algorithm> #include<cstring> using namespace std; const int N=705,MOD=1e9+7; char s[N]; long long n,f[N][N][5][5]; int st[N],top=0,m[N]; void match(){ for(int i=1;i<=